JUCE: Button Class Reference

JUCE

Classes | Public Types | Public Member Functions | Public Attributes | Protected Member Functions | List of all members
Button Class Referenceabstract
juce_gui_basics » buttons

A base class for buttons. More...

`#include <juce_Button.h>`

Inheritance diagram for Button:

## Classes
class | Listener
| Used to receive callbacks when a button is clicked. More...
struct | LookAndFeelMethods
| This abstract base class is implemented by LookAndFeel classes to provide button-drawing functionality. More...

## Public Types
enum | ConnectedEdgeFlags { ConnectedOnLeft = 1 , ConnectedOnRight = 2 , ConnectedOnTop = 4 , ConnectedOnBottom = 8 }
| A combination of these flags are used by setConnectedEdges(). More...
enum | ButtonState { buttonNormal , buttonOver , buttonDown }
| Used by setState(). More...
Public Types inherited from Component
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...

## Public Member Functions
| ~Button () override
| Destructor. More...
void | setButtonText (const String &newText)
| Changes the button's text. More...
const String & | getButtonText () const
| Returns the text displayed in the button. More...
bool | isDown () const noexcept
| Returns true if the button is currently being held down. More...
bool | isOver () const noexcept
| Returns true if the mouse is currently over the button. More...
void | setToggleable (bool shouldBeToggleable)
| Indicates that the button's on/off state is toggleable. More...
bool | isToggleable () const noexcept
| Returns true if the button's on/off state is toggleable. More...
void | setToggleState (bool shouldBeOn, NotificationType notification)
| A button has an on/off state associated with it, and this changes that. More...
bool | getToggleState () const noexcept
| Returns true if the button is 'on'. More...
Value & | getToggleStateValue () noexcept
| Returns the Value object that represents the button's toggle state. More...
void | setClickingTogglesState (bool shouldAutoToggleOnClick) noexcept
| This tells the button to automatically flip the toggle state when the button is clicked. More...
bool | getClickingTogglesState () const noexcept
| Returns true if this button is set to be an automatic toggle-button. More...
void | setRadioGroupId (int newGroupId, NotificationType notification=sendNotification)
| Enables the button to act as a member of a mutually-exclusive group of 'radio buttons'. More...
int | getRadioGroupId () const noexcept
| Returns the ID of the group to which this button belongs. More...
void | addListener (Listener *newListener)
| Registers a listener to receive events when this button's state changes. More...
void | removeListener (Listener *listener)
| Removes a previously-registered button listener. More...
virtual void | triggerClick ()
| Causes the button to act as if it's been clicked. More...
void | setCommandToTrigger (ApplicationCommandManager *commandManagerToUse, CommandID commandID, bool generateTooltip)
| Sets a command ID for this button to automatically invoke when it's clicked. More...
CommandID | getCommandID () const noexcept
| Returns the command ID that was set by setCommandToTrigger(). More...
void | addShortcut (const KeyPress &)
| Assigns a shortcut key to trigger the button. More...
void | clearShortcuts ()
| Removes all key shortcuts that had been set for this button. More...
bool | isRegisteredForShortcut (const KeyPress &) const
| Returns true if the given keypress is a shortcut for this button. More...
void | setRepeatSpeed (int initialDelayInMillisecs, int repeatDelayInMillisecs, int minimumDelayInMillisecs=-1) noexcept
| Sets an auto-repeat speed for the button when it is held down. More...
void | setTriggeredOnMouseDown (bool isTriggeredOnMouseDown) noexcept
| Sets whether the button click should happen when the mouse is pressed or released. More...
bool | getTriggeredOnMouseDown () const noexcept
| Returns whether the button click happens when the mouse is pressed or released. More...
uint32 | getMillisecondsSinceButtonDown () const noexcept
| Returns the number of milliseconds since the last time the button went into the 'down' state. More...
void | setTooltip (const String &newTooltip) override
| Sets the tooltip for this button. More...
void | setConnectedEdges (int connectedEdgeFlags)
| Hints about which edges of the button might be connected to adjoining buttons. More...
int | getConnectedEdgeFlags () const noexcept
| Returns the set of flags passed into setConnectedEdges(). More...
bool | isConnectedOnLeft () const noexcept
| Indicates whether the button adjoins another one on its left edge. More...
bool | isConnectedOnRight () const noexcept
| Indicates whether the button adjoins another one on its right edge. More...
bool | isConnectedOnTop () const noexcept
| Indicates whether the button adjoins another one on its top edge. More...
bool | isConnectedOnBottom () const noexcept
| Indicates whether the button adjoins another one on its bottom edge. More...
void | setState (ButtonState newState)
| Can be used to force the button into a particular state. More...
ButtonState | getState () const noexcept
| Returns the button's current over/down/up state. More...
Public Member Functions inherited from Component
| Component () noexcept
| Creates a component. More...
| ~Component () override
| Destructor. More...
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time. More...
String | getName () const noexcept
| Returns the name of this component. More...
virtual void | setName (const String &newName)
| Sets the name of this component. More...
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID(). More...
void | setComponentID (const String &newID)
| Sets the component's ID string. More...
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible. More...
bool | isVisible () const noexcept
| Tests whether the component is visible or not. More...
virtual void | visibilityChanged ()
| Called when this component's visibility changes. More...
bool | isShowing () const
| Tests whether this component and all its parents are visible. More...
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop. More...
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it. More...
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop. More...
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component. More...
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window. More...
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised. More...
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop. More...
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings. More...
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings. More...
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component. More...
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings. More...
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings. More...
int | getX () const noexcept
| Returns the x coordinate of the component's left edge. More...
int | getY () const noexcept
| Returns the y coordinate of the top of this component. More...
int | getWidth () const noexcept
| Returns the component's width in pixels. More...
int | getHeight () const noexcept
| Returns the component's height in pixels. More...
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge. More...
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point. More...
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component. More...
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box. More...
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin. More...
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers. More...
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin. More...
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin. More...
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left. More...
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left. More...
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space. More...
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space. More...
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space. More...
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space. More...
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate. More...
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate. More...
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate. More...
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate. More...
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position. More...
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position. More...
void | setTopRightPosition (int x, int y)
| Moves the component to a new position. More...
void | setSize (int newWidth, int newHeight)
| Changes the size of the component. More...
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size. More...
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size. More...
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size. More...
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size. More...
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it. More...
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged. More...
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre. More...
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre. More...
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre. More...
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent. More...
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component. More...
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component. More...
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component. More...
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width. More...
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height. More...
int | getParentWidth () const noexcept
| Returns the width of the component's parent. More...
int | getParentHeight () const noexcept
| Returns the height of the component's parent. More...
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component. More...
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains. More...
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index. More...
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components. More...
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components. More...
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID. More...
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one. More...
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one. More...
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already. More...
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already. More...
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID. More...
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components. More...
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index. More...
void | removeAllChildren ()
| Removes all this component's children. More...
void | deleteAllChildren ()
| Removes and deletes all of this component's children. More...
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside. More...
template<class TargetClass >
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class. More...
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents. More...
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children. More...
virtual void | parentHierarchyChanged ()
| Called to indicate that the component's parents have changed. More...
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes. More...
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component. More...
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method. More...
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags. More...
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children. More...
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children. More...
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account. More...
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account. More...
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one. More...
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one. More...
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one. More...
void | repaint ()
| Marks the whole component as needing to be redrawn. More...
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn. More...
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn. More...
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing. More...
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f)
| Generates a snapshot of part of this component. More...
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context. More...
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted. More...
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted. More...
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance. More...
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect. More...
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component. More...
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component. More...
virtual void | lookAndFeelChanged ()
| Called to let the component react to a change in the look-and-feel setting. More...
void | sendLookAndFeelChange ()
| Calls the lookAndFeelChanged() method in this component and all its children. More...
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent. More...
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent. More...
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked. More...
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on. More...
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component. More...
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified. More...
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports. More...
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container. More...
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container. More...
Component * | findFocusContainer () const
| Returns the focus container for this component. More...
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component. More...
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not. More...
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus. More...
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus. More...
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus(). More...
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component. More...
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component. More...
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus. More...
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings. More...
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component. More...
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component. More...
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus. More...
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline. More...
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled. More...
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component. More...
virtual void | enablementChanged ()
| Callback to indicate that this component has been enabled or disabled. More...
float | getAlpha () const noexcept
| Returns the component's current transparency level. More...
void | setAlpha (float newAlpha)
| Changes the transparency of this component. More...
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component. More...
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component. More...
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component. More...
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated. More...
virtual void | paint (Graphics &g)
| Components can override this method to draw their content. More...
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children. More...
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component. More...
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component. More...
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component. More...
void | mouseDown (const MouseEvent &event) override
| Called when a mouse button is pressed. More...
void | mouseDrag (const MouseEvent &event) override
| Called when the mouse is moved while a button is held down. More...
void | mouseUp (const MouseEvent &event) override
| Called when a mouse button is released. More...
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component. More...
void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel) override
| Called when the mouse-wheel is moved. More...
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used. More...
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component. More...
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component. More...
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener. More...
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives. More...
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener. More...
virtual bool | keyPressed (const KeyPress &key)
| Called when a key is pressed. More...
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released. More...
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released. More...
virtual void | focusGained (FocusChangeType cause)
| Called to indicate that this component has just acquired the keyboard focus. More...
virtual void | focusLost (FocusChangeType cause)
| Called to indicate that this component has just lost the keyboard focus. More...
virtual void | focusOfChildComponentChanged (FocusChangeType cause)
| Called to indicate a change in whether or not this component is the parent of the currently-focused component. More...
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component. More...
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component. More...
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component. More...
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component. More...
virtual void | resized ()
| Called when this component's size has been changed. More...
virtual void | moved ()
| Called when this component's position has been changed. More...
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized. More...
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized. More...
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings. More...
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position. More...
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener. More...
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component. More...
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage(). More...
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates. More...
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state. More...
void | exitModalState (int returnValue)
| Ends a component's modal state. More...
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one. More...
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages. More...
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events. More...
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component. More...
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component. More...
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component. More...
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number. More...
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose. More...
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it. More...
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method. More...
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component. More...
virtual void | colourChanged ()
| This method is called when a colour is changed by the setColour() method. More...
void * | getWindowHandle () const
| Returns the underlying native window handle for this component. More...
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component. More...
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component. More...
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting. More...
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage(). More...
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled. More...
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag. More...
String | getTitle () const noexcept
| Returns the title text for this component. More...
void | setTitle (const String &newTitle)
| Sets the title for this component. More...
String | getDescription () const noexcept
| Returns the description for this component. More...
void | setDescription (const String &newDescription)
| Sets the description for this component. More...
String | getHelpText () const noexcept
| Returns the help text for this component. More...
void | setHelpText (const String &newHelpText)
| Sets the help text for this component. More...
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients. More...
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients. More...
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible. More...
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component. More...
Public Member Functions inherited from MouseListener
virtual | ~MouseListener ()=default
| Destructor. More...
virtual void | mouseMove (const MouseEvent &event)
| Called when the mouse moves inside a component. More...
virtual void | mouseEnter (const MouseEvent &event)
| Called when the mouse first enters a component. More...
virtual void | mouseExit (const MouseEvent &event)
| Called when the mouse moves out of a component. More...
virtual void | mouseDown (const MouseEvent &event)
| Called when a mouse button is pressed. More...
virtual void | mouseDrag (const MouseEvent &event)
| Called when the mouse is moved while a button is held down. More...
virtual void | mouseUp (const MouseEvent &event)
| Called when a mouse button is released. More...
virtual void | mouseDoubleClick (const MouseEvent &event)
| Called when a mouse button has been double-clicked on a component. More...
virtual void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel)
| Called when the mouse-wheel is moved. More...
virtual void | mouseMagnify (const MouseEvent &event, float scaleFactor)
| Called when a pinch-to-zoom mouse-gesture is used. More...
Public Member Functions inherited from SettableTooltipClient
| ~SettableTooltipClient () override=default
| Destructor. More...
virtual void | setTooltip (const String &newTooltip)
| Assigns a new tooltip to this object. More...
String | getTooltip () override
| Returns the tooltip assigned to this object. More...
Public Member Functions inherited from TooltipClient
virtual | ~TooltipClient ()=default
| Destructor. More...
virtual String | getTooltip ()=0
| Returns the string that this object wants to show as its tooltip. More...

## Public Attributes
std::function< void()> | onClick
| You can assign a lambda to this callback object to have it called when the button is clicked. More...
std::function< void()> | onStateChange
| You can assign a lambda to this callback object to have it called when the button's state changes. More...

## Protected Member Functions
| Button (const String &buttonName)
| Creates a button. More...
virtual void | clicked ()
| This method is called when the button has been clicked. More...
virtual void | clicked (const ModifierKeys &modifiers)
| This method is called when the button has been clicked. More...
virtual void | paintButton (Graphics &g, bool shouldDrawButtonAsHighlighted, bool shouldDrawButtonAsDown)=0
| Subclasses should override this to actually paint the button's contents. More...
virtual void | buttonStateChanged ()
| Called when the button's up/down/over state changes. More...
virtual void | internalClickCallback (const ModifierKeys &)
void | handleCommandMessage (int commandId) override
void | mouseEnter (const MouseEvent &) override
void | mouseExit (const MouseEvent &) override
void | mouseDown (const MouseEvent &) override
void | mouseDrag (const MouseEvent &) override
void | mouseUp (const MouseEvent &) override
bool | keyPressed (const KeyPress &) override
void | paint (Graphics &) override
void | parentHierarchyChanged () override
void | visibilityChanged () override
void | focusGained (FocusChangeType) override
void | focusLost (FocusChangeType) override
void | enablementChanged () override
virtual bool | keyStateChanged (bool isKeyDown)
Protected Member Functions inherited from SettableTooltipClient
| SettableTooltipClient ()=default

## Additional Inherited Members
Static Public Member Functions inherited from Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor. More...
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus. More...
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it. More...
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation. More...
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down. More...
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state. More...
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal. More...

## Detailed Description

A base class for buttons.

This contains all the logic for button behaviours such as enabling/disabling, responding to shortcut keystrokes, auto-repeating when held down, toggle-buttons and radio groups, etc.

See also
  TextButton, DrawableButton, ToggleButton

## Member Enumeration Documentation

## ◆ ConnectedEdgeFlags

enum Button::ConnectedEdgeFlags

A combination of these flags are used by setConnectedEdges().

Enumerator
ConnectedOnLeft |
ConnectedOnRight |
ConnectedOnTop |
ConnectedOnBottom |

## ◆ ButtonState

enum Button::ButtonState

Used by setState().

Enumerator
buttonNormal |
buttonOver |
buttonDown |

## Constructor & Destructor Documentation

## ◆ Button()

Button::Button | ( | const String & | buttonName | ) |
| explicitprotected

Creates a button.

Parameters

  buttonName | the text to put in the button (the component's name is also initially set to this string, but these can be changed later using the setName() and setButtonText() methods)

## ◆ ~Button()

Button::~Button | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ setButtonText()

void Button::setButtonText | ( | const String & | newText | ) |

Changes the button's text.

See also
  getButtonText

## ◆ getButtonText()

const String & Button::getButtonText | ( |  | ) | const

Returns the text displayed in the button.

See also
  setButtonText

## ◆ isDown()

bool Button::isDown | ( |  | ) | const
| noexcept

Returns true if the button is currently being held down.

See also
  isOver

## ◆ isOver()

bool Button::isOver | ( |  | ) | const
| noexcept

Returns true if the mouse is currently over the button.

This will be also be true if the button is being held down.

See also
  isDown

## ◆ setToggleable()

void Button::setToggleable | ( | bool | shouldBeToggleable | ) |

Indicates that the button's on/off state is toggleable.

By default this is false, and will only be true for ToggleButtons, buttons that are a part of a radio button group, and buttons for which getClickingTogglesState() == true, however you can use this method to manually indicate that a button is toggleable.

This will present the button as toggleable to accessibility clients and add an accessible "toggle" action for the button that invokes setToggleState().

See also
  ToggleButton, isToggleable, setToggleState, setClickingTogglesState, setRadioGroupId

## ◆ isToggleable()

bool Button::isToggleable | ( |  | ) | const
| noexcept

Returns true if the button's on/off state is toggleable.

See also
  setToggleable, setClickingTogglesState

## ◆ setToggleState()

void Button::setToggleState | ( | bool | shouldBeOn,
|  | NotificationType | notification
| ) |  |

A button has an on/off state associated with it, and this changes that.

By default buttons are 'off' and for simple buttons that you click to perform an action you won't change this. Toggle buttons, however will want to change their state when turned on or off.

Parameters

  shouldBeOn | whether to set the button's toggle state to be on or off. If it's a member of a button group, this will always try to turn it on, and to turn off any other buttons in the group
  notification | determines the behaviour if the value changes - this can invoke a synchronous call to clicked(), but sendNotificationAsync is not supported

See also
  getToggleState, setRadioGroupId

## ◆ getToggleState()

bool Button::getToggleState | ( |  | ) | const
| noexcept

Returns true if the button is 'on'.

By default buttons are 'off' and for simple buttons that you click to perform an action you won't change this. Toggle buttons, however will want to change their state when turned on or off.

See also
  setToggleState

## ◆ getToggleStateValue()

Value & Button::getToggleStateValue | ( |  | ) |
| noexcept

Returns the Value object that represents the button's toggle state.

You can use this Value object to connect the button's state to external values or setters, either by taking a copy of the Value, or by using Value::referTo() to make it point to your own Value object.

See also
  getToggleState, Value

## ◆ setClickingTogglesState()

void Button::setClickingTogglesState | ( | bool | shouldAutoToggleOnClick | ) |
| noexcept

This tells the button to automatically flip the toggle state when the button is clicked.

If set to true, then before the clicked() callback occurs, the toggle-state of the button is flipped. This will also cause isToggleable() to return true.

See also
  isToggleable

## ◆ getClickingTogglesState()

bool Button::getClickingTogglesState | ( |  | ) | const
| noexcept

Returns true if this button is set to be an automatic toggle-button.

This returns the last value that was passed to setClickingTogglesState().

## ◆ setRadioGroupId()

void Button::setRadioGroupId | ( | int | newGroupId,
|  | NotificationType | notification = `sendNotification`
| ) |  |

Enables the button to act as a member of a mutually-exclusive group of 'radio buttons'.

If the group ID is set to a non-zero number, then this button will act as part of a group of buttons with the same ID, only one of which can be 'on' at the same time. Note that when it's part of a group, clicking a toggle-button that's 'on' won't turn it off.

To find other buttons with the same ID, this button will search through its sibling components for ToggleButtons, so all the buttons for a particular group must be placed inside the same parent component.

Set the group ID back to zero if you want it to act as a normal toggle button again.

The notification argument lets you specify how other buttons should react to being turned on or off in response to this call.

See also
  getRadioGroupId

## ◆ getRadioGroupId()

int Button::getRadioGroupId | ( |  | ) | const
| noexcept

Returns the ID of the group to which this button belongs.

(See setRadioGroupId() for an explanation of this).

## ◆ addListener()

void Button::addListener | ( | Listener * | newListener | ) |

Registers a listener to receive events when this button's state changes.

If the listener is already registered, this will not register it again.

See also
  removeListener

## ◆ removeListener()

void Button::removeListener | ( | Listener * | listener | ) |

Removes a previously-registered button listener.

See also
  addListener

## ◆ triggerClick()

virtual void Button::triggerClick | ( |  | ) |
| virtual

Causes the button to act as if it's been clicked.

This will asynchronously make the button draw itself going down and up, and will then call back the clicked() method as if mouse was clicked on it.

See also
  clicked

## ◆ setCommandToTrigger()

void Button::setCommandToTrigger | ( | ApplicationCommandManager * | commandManagerToUse,
|  | CommandID | commandID,
|  | bool | generateTooltip
| ) |  |

Sets a command ID for this button to automatically invoke when it's clicked.

When the button is pressed, it will use the given manager to trigger the command ID.

Obviously be careful that the ApplicationCommandManager doesn't get deleted before this button is. To disable the command triggering, call this method and pass nullptr as the command manager.

If generateTooltip is true, then the button's tooltip will be automatically generated based on the name of this command and its current shortcut key.

See also
  addShortcut, getCommandID

## ◆ getCommandID()

CommandID Button::getCommandID | ( |  | ) | const
| noexcept

Returns the command ID that was set by setCommandToTrigger().

## ◆ addShortcut()

void Button::addShortcut | ( | const KeyPress & |  | ) |

Assigns a shortcut key to trigger the button.

The button registers itself with its top-level parent component for keypresses.

Note that a different way of linking buttons to keypresses is by using the setCommandToTrigger() method to invoke a command.

See also
  clearShortcuts

## ◆ clearShortcuts()

void Button::clearShortcuts | ( |  | ) |

Removes all key shortcuts that had been set for this button.

See also
  addShortcut

## ◆ isRegisteredForShortcut()

bool Button::isRegisteredForShortcut | ( | const KeyPress & |  | ) | const

Returns true if the given keypress is a shortcut for this button.

See also
  addShortcut

## ◆ setRepeatSpeed()

void Button::setRepeatSpeed | ( | int | initialDelayInMillisecs,
|  | int | repeatDelayInMillisecs,
|  | int | minimumDelayInMillisecs = `-1`
| ) |  |
| noexcept

Sets an auto-repeat speed for the button when it is held down.

(Auto-repeat is disabled by default).

Parameters

  initialDelayInMillisecs | how long to wait after the mouse is pressed before triggering the next click. If this is zero, auto-repeat is disabled
  repeatDelayInMillisecs | the frequently subsequent repeated clicks should be triggered
  minimumDelayInMillisecs | if this is greater than 0, the auto-repeat speed will get faster, the longer the button is held down, up to the minimum interval specified here

## ◆ setTriggeredOnMouseDown()

void Button::setTriggeredOnMouseDown | ( | bool | isTriggeredOnMouseDown | ) |
| noexcept

Sets whether the button click should happen when the mouse is pressed or released.

By default the button is only considered to have been clicked when the mouse is released, but setting this to true will make it call the clicked() method as soon as the button is pressed.

This is useful if the button is being used to show a pop-up menu, as it allows the click to be used as a drag onto the menu.

## ◆ getTriggeredOnMouseDown()

bool Button::getTriggeredOnMouseDown | ( |  | ) | const
| noexcept

Returns whether the button click happens when the mouse is pressed or released.

See also
  setTriggeredOnMouseDown

## ◆ getMillisecondsSinceButtonDown()

uint32 Button::getMillisecondsSinceButtonDown | ( |  | ) | const
| noexcept

Returns the number of milliseconds since the last time the button went into the 'down' state.

## ◆ setTooltip()

void Button::setTooltip | ( | const String & | newTooltip | ) |
| overridevirtual

Sets the tooltip for this button.

See also
  TooltipClient, TooltipWindow

Reimplemented from SettableTooltipClient.

## ◆ setConnectedEdges()

void Button::setConnectedEdges | ( | int | connectedEdgeFlags | ) |

Hints about which edges of the button might be connected to adjoining buttons.

The value passed in is a bitwise combination of any of the values in the ConnectedEdgeFlags enum.

E.g. if you are placing two buttons adjacent to each other, you could use this to indicate which edges are touching, and the LookAndFeel might choose to drawn them without rounded corners on the edges that connect. It's only a hint, so the LookAndFeel can choose to ignore it if it's not relevant for this type of button.

## ◆ getConnectedEdgeFlags()

int Button::getConnectedEdgeFlags | ( |  | ) | const
| noexcept

Returns the set of flags passed into setConnectedEdges().

## ◆ isConnectedOnLeft()

bool Button::isConnectedOnLeft | ( |  | ) | const
| noexcept

Indicates whether the button adjoins another one on its left edge.

See also
  setConnectedEdges

## ◆ isConnectedOnRight()

bool Button::isConnectedOnRight | ( |  | ) | const
| noexcept

Indicates whether the button adjoins another one on its right edge.

See also
  setConnectedEdges

## ◆ isConnectedOnTop()

bool Button::isConnectedOnTop | ( |  | ) | const
| noexcept

Indicates whether the button adjoins another one on its top edge.

See also
  setConnectedEdges

## ◆ isConnectedOnBottom()

bool Button::isConnectedOnBottom | ( |  | ) | const
| noexcept

Indicates whether the button adjoins another one on its bottom edge.

See also
  setConnectedEdges

## ◆ setState()

void Button::setState | ( | ButtonState | newState | ) |

Can be used to force the button into a particular state.

This only changes the button's appearance, it won't trigger a click, or stop any mouse-clicks from happening.

The state that you set here will only last until it is automatically changed when the mouse enters or exits the button, or the mouse-button is pressed or released.

## ◆ getState()

ButtonState Button::getState | ( |  | ) | const
| noexcept

Returns the button's current over/down/up state.

## ◆ clicked() [1/2]

virtual void Button::clicked | ( |  | ) |
| protectedvirtual

This method is called when the button has been clicked.

Subclasses can override this to perform whatever actions they need to do. In general, you wouldn't use this method to receive clicks, but should get your callbacks by attaching a std::function to the onClick callback, or adding a Button::Listener.

See also
  triggerClick, onClick

Reimplemented in HyperlinkButton.

## ◆ clicked() [2/2]

virtual void Button::clicked | ( | const ModifierKeys & | modifiers | ) |
| protectedvirtual

This method is called when the button has been clicked.

By default it just calls clicked(), but you might want to override it to handle things like clicking when a modifier key is pressed, etc.

See also
  ModifierKeys

Reimplemented in TabBarButton.

## ◆ paintButton()

virtual void Button::paintButton | ( | Graphics & | g,
|  | bool | shouldDrawButtonAsHighlighted,
|  | bool | shouldDrawButtonAsDown
| ) |  |
| protectedpure virtual

Subclasses should override this to actually paint the button's contents.

It's better to use this than the paint method, because it gives you information about the over/down state of the button.

Parameters

  g | the graphics context to use
  shouldDrawButtonAsHighlighted | true if the button is either in the 'over' or 'down' state
  shouldDrawButtonAsDown | true if the button should be drawn in the 'down' position

Implemented in ToolbarItemComponent, ArrowButton, DrawableButton, HyperlinkButton, ImageButton, ShapeButton, TextButton, ToggleButton, and TabBarButton.

## ◆ buttonStateChanged()

virtual void Button::buttonStateChanged | ( |  | ) |
| protectedvirtual

Called when the button's up/down/over state changes.

Subclasses can override this if they need to do something special when the button goes up or down.

See also
  isDown, isOver

Reimplemented in DrawableButton, and ToolbarButton.

## ◆ internalClickCallback()

virtual void Button::internalClickCallback | ( | const ModifierKeys & |  | ) |
| protectedvirtual

## ◆ handleCommandMessage()

void Button::handleCommandMessage | ( | int | commandId | ) |
| overrideprotectedvirtual

Reimplemented from Component.

## ◆ mouseEnter()

void Button::mouseEnter | ( | const MouseEvent & |  | ) |
| overrideprotectedvirtual

Reimplemented from MouseListener.

## ◆ mouseExit()

void Button::mouseExit | ( | const MouseEvent & |  | ) |
| overrideprotectedvirtual

Reimplemented from MouseListener.

## ◆ mouseDown()

void Button::mouseDown | ( | const MouseEvent & |  | ) |
| overrideprotectedvirtual

Reimplemented from MouseListener.

## ◆ mouseDrag()

void Button::mouseDrag | ( | const MouseEvent & |  | ) |
| overrideprotectedvirtual

Reimplemented from MouseListener.

## ◆ mouseUp()

void Button::mouseUp | ( | const MouseEvent & |  | ) |
| overrideprotectedvirtual

Reimplemented from MouseListener.

## ◆ keyPressed()

bool Button::keyPressed | ( | const KeyPress & |  | ) |
| overrideprotectedvirtual

Reimplemented from Component.

## ◆ paint()

void Button::paint | ( | Graphics & |  | ) |
| overrideprotectedvirtual

Reimplemented from Component.

## ◆ parentHierarchyChanged()

void Button::parentHierarchyChanged | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from Component.

## ◆ visibilityChanged()

void Button::visibilityChanged | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from Component.

## ◆ focusGained()

void Button::focusGained | ( | FocusChangeType |  | ) |
| overrideprotectedvirtual

Reimplemented from Component.

## ◆ focusLost()

void Button::focusLost | ( | FocusChangeType |  | ) |
| overrideprotectedvirtual

Reimplemented from Component.

## ◆ enablementChanged()

void Button::enablementChanged | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from Component.

Reimplemented in DrawableButton, and ToolbarButton.

## ◆ keyStateChanged()

virtual bool Component::keyStateChanged | ( | bool | isKeyDown | ) |
| protectedvirtual

Reimplemented from Component.

## Member Data Documentation

## ◆ onClick

std::function<void()> Button::onClick

You can assign a lambda to this callback object to have it called when the button is clicked.

## ◆ onStateChange

std::function<void()> Button::onStateChange

You can assign a lambda to this callback object to have it called when the button's state changes.

The documentation for this class was generated from the following file:

- juce_Button.h